//========================================================================================
//
//	File:				FWPlatMe.h
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWPLATME_H
#define FWPLATME_H

#ifndef FWPRIDEB_H
#include <FWPriDeb.h>
#endif

#include <StdDef.h>
#include <Assert.h>

#include <Memory.h>


//========================================================================================
// Type definitions
//========================================================================================

#ifdef __xlC
typedef unsigned long SIZE_T;
#else
typedef size_t SIZE_T;
#endif


//========================================================================================
// Defines
//========================================================================================

#define PLATFORM_ASSERT(condition) FW_ASSERT(condition)
#define PLATFORM_DEBUGGER_STRING(string) // DebugStr("\p##string")
#define PLATFORM_PRINT_STRING(string) // fprintf(stderr, string)


//========================================================================================
// Global function declarations
//========================================================================================

void *PlatformAllocateBlock(size_t size);
void PlatformFreeBlock(void *ptr);

//----------------------------------------------------------------------------------------
// PlatformCopyMemory
//----------------------------------------------------------------------------------------

inline void PlatformCopyMemory(void *source, void *destination, size_t length)
{
	BlockMove(source, destination, (Size) length);
}

#endif
